package cz.kebrt.unitcheck.ant;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import cz.kebrt.unitcheck.UnitChecker;
import cz.kebrt.unitcheck.config.Config;
import cz.kebrt.unitcheck.config.ConfigException;
import cz.kebrt.unitcheck.config.TestConfig;
import cz.kebrt.unitcheck.runner.ConsoleUnitCheckListener;
import cz.kebrt.unitcheck.util.PathPrinter;

public class SampleTask extends Task {

	@Override
	public void execute() throws BuildException {
		try {
			Config config = new Config();
			config.setLibDir("/home/michal/diplomka/unitcheck/trunk/ant-task/lib");
			Thread.currentThread().setContextClassLoader(this.getClass().getClassLoader());

			config.setOneTest(new TestConfig("cz.kebrt.unitcheck.test.Deadlock"));
			PathPrinter.Config pathConfig = new PathPrinter.Config(false, false);
			UnitChecker uc = new UnitChecker(config);
			uc.addListener(new ConsoleUnitCheckListener(System.out, pathConfig, true));

			uc.run();
		} catch (ConfigException e) {
			System.err.println(e.getMessage());
		}
	}

}
